/********************************** (C) COPYRIGHT *******************************
 * File Name          : usb_desc.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2022/08/20
 * Description        : usb device descriptor,configuration descriptor,
 *                      string descriptors and other descriptors.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

#include "usb_desc.h"

/* Device Descriptor */
const uint8_t  MyDevDescr[] =
{
        0x12,           //豸ȣ18ֽ
        0x01,           //ͣ0x01Ϊ豸
        0x10,0x01,      //豸ʹUSB汾Э飬ΪС˽ṹԵֽǰUSB1.1汾Ϊ0x10,0x01USB2.0Ϊ0x00,0x02
        0x02,           //룬CDCΪ0x02CDC豸ָ豸ͣ0x02üӿڣᱻϵͳΪһUSB豸Ӷ豸
        //ָ豸Ϊͨ豸ʹõЭ鶼ָΪ0.
        0x00,           //룬bDeviceClassΪ0ʱbDeviceSubClassҲΪ0
        0x00,           //豸ʹõЭ飬ЭUSBЭ涨ֶΪ0ʱʾ豸ʹЭ顣
        DEF_USBD_UEP0_SIZE,     //˵0ȡֵ8163264˴Ϊ64ֽ
        0x86,0x1a,      //ID
        0x00,0x01,      //Ʒ豸ID
        0x00,0x01,      //豸汾
        0x01,           //̵ֵֵַΪ0ʱʾûгַ
        0x02,           //ƷֵֵַΪ0ʱʾûвƷַ
        0x00,           //豸кֵֵַΪ0ʱʾûкַ
        0x01,           //ܵͨΪ1
};

/* Configuration Descriptor */
const uint8_t  MyCfgDescr[] =
{
        //ӿڣ
        0x09,          //ȣ׼USBΪ9ֽ
        0x02,          //ͣΪ0x02
        0x43,0x00,     //ܳȣ67ֽ
        0x02,          //ֵ֧Ľӿ2ӿ
        0x01,          //ʾõֵ
        0x00,          //õֵַ0x00ʾûַ
        0x80,          //豸һЩԣ繩緽ʽͻѵȣ0x80ʾ豸߹
        0x32,          //豸Ҫ߻ȡ0x32ʾ100ma

        //Ϊӿ0CDCӿڣӿܵأ븽һ
        0x09,          //ӿȣ׼USBӿΪ9ֽ
        0x04,          //ͣӿΪ0x04
        0x00,          //ýӿڵıţ0ʼ˴Ϊ0x00
        0x00,          //ýӿڵıñ,ͨΪ0
        0x01,          //ýӿʹõĶ˵0x01ʾʹ1˵㡣ֶΪ0ʾûз0˵㣬ֻʹĬϵĿƶ˵㡣CDCӿֻʹһж˵
        0x02,          //ýӿʹõ࣬0x02ΪCDC
        0x02,          //ýӿʹõ࣬ҪʵUSBתڣͱʹAbstract Control Modelģͣ࣬ıΪ0x02
        0x01,          //ýӿʹõЭ飬ʹCommon AT CommandsͨATЭ
        0x00,          //ýӿڵֵַ0x00ʾûַ

        //Ϊӿ
        //ҪӿڵĹܣCDCӿڣӿڣ֮
        //Header Functional Descriptor
        0x05,          //ùĳȣ5ֽ
        0x24,          //̶ͣλ0x24CS_INTERFACEı룩
        0x00,          //
        0x10,0x01,     //USBͨ豸Эİ汾š˴ΪUSB1.1

        //(ûӿ)
        //Call Management Functional Descriptor
        0x05,          //ùĳȣ5ֽ
        0x24,          //̶ͣλ0x24CS_INTERFACEı룩
        0x01,          //
        0x00,          //豸ֻλD0D1壬λΪֵ0D0Ϊ0ʾ豸ԼùΪ1ʾԼ
        0x00,          //ʾѡùӿڱţڲʹӿùֶΪ0

        //Abstract Control Management Functional Descriptor  ƹ
        0x04,          //ùĳȣ4ֽ
        0x24,          //̶ͣλ0x24CS_INTERFACEı룩
        0x02,          //
        0x02,          //豸D7-4λΪλΪ0֧Set_Line_CodingSet_Control_Line_StateGet_Line_CodingSerial_State֪ͨ
                       //D0ʾǷ֧Set_Comm_FeatureClear_Comm_FeatureGet_Comm_Feature,Ϊ1ʾ֧֣
                       //D1λʾǷ֧Set_Line_CodingSet_Control_Line_StateGet_Line_CodingSerial_State֪ͨΪ1ʾ֧
                       //D2ΪʾǷ֧Send_BreakΪ1ʾ֧
                       //D3ʾǷ֧Network_Connection֪ͨΪ1ʾ֧

        //Union Functional Descriptor5ֽڣһӿ֮ĹϵԱΪһܵԪЩӿһΪӿڣΪӽӿ
        0x05,          //ùĳȣ5ֽ
        0x24,          //̶ͣλ0x24CS_INTERFACEı룩
        0x06,          //
        0x00,          //ֽΪӿڱţ˴ΪΪ0CDCӿ
        0x01,          //ֽΪһӽӿڱţ˴Ϊ1ӿڣֻһӽӿ

        //ӿ0CDCӿڣĶ˵
        0x07,          //˵ȣ7ֽ
        0x05,          //ͣ˵Ϊ0x05
        0x81,          //ö˵ĵַ0x81ʾ˵1Ϊ
        0x03,          //ö˵ԡλD1-0ʾö˵Ĵͣ0Ϊƴ䣬1Ϊʱ䣬2Ϊ䣬3Ϊжϴ
        DEF_USBD_ENDP1_SIZE,0x00,     //ö˵ֵ֧ȣ64ֽ
        0x01,          //˵Ĳѯʱ

        //Ϊӿ1ݽӿڣ
        //CDCӿڣӿ0Ǹ豸ģĴݴӿڽеġֻʹһӿڣΪ1
        0x09,          //ӿȣ9ֽ
        0x04,          //ͣӿΪ0x04
        0x01,          //ýӿڵıţ0ʼ˴Ϊ0x01
        0x00,          //ýӿڵıñ
        0x02,          //ýӿʹõĶ˵ýӿҪʹһ˵㣬˵Ϊ2
        0x0a,          //ýӿʹõ࣬0x0aΪCDC
        0x00,          //ýӿʹõ
        0x00,          //ýӿʹõЭ
        0x00,          //ýӿڵֵַ0x00ʾûַ

        //ӿ1ӿڣĶ˵
        0x07,          //˵ȣ7ֽ
        0x05,          //ͣ˵Ϊ0x05
        0x02,          //ö˵ĵַ0x02ʾ˵2Ϊ
        0x02,          //ö˵ԡλD1-0ʾö˵Ĵͣ0Ϊƴ䣬1Ϊʱ䣬2Ϊ䣬3Ϊжϴ
        DEF_USBD_ENDP2_SIZE,0x00,     //ö˵ֵ֧ȣ64ֽ
        0x00,          //˵Ĳѯʱ䣬˵Ч


        0x07,          //˵ȣ7ֽ
        0x05,          //ͣ˵Ϊ0x05
        0x83,          //ö˵ĵַ0x83ʾ˵3Ϊ
        0x02,          //ö˵ԡλD1-0ʾö˵Ĵͣ0Ϊƴ䣬1Ϊʱ䣬2Ϊ䣬3Ϊжϴ
        DEF_USBD_ENDP3_SIZE,0x00,     //ö˵ֵ֧ȣ64ֽ
        0x00,          //˵Ĳѯʱ䣬˵Ч
};

/* Language Descriptor */
const uint8_t  MyLangDescr[] =
{
    0x04, 0x03, 0x09, 0x04
};

/* Manufacturer Descriptor */
const uint8_t  MyManuInfo[] =
{
    0x0E, 0x03, 'w', 0, 'c', 0, 'h', 0, '.', 0, 'c', 0, 'n', 0
};

/* Product Information */
const uint8_t  MyProdInfo[] =
{
    0x16, 0x03, 'U', 0x00, 'S', 0x00, 'B', 0x00, ' ', 0x00, 'S', 0x00, 'e', 0x00,
                    'r', 0x00, 'i', 0x00, 'a', 0x00, 'l', 0x00
};

/* Serial Number Information */
const uint8_t  MySerNumInfo[] =
{
    0x16, 0x03, '0', 0, '1', 0, '2', 0, '3', 0, '4', 0, '5', 0
              , '6', 0, '7', 0, '8', 0, '9', 0
};

